/**
 * Funkce ocekava oba vstupni obrazy \e in a \e pattern, ze jsou jiz defacto masky.
 * Maske \e pattern je postupne prikladana na vstupni obraz \e in a pro kazde takove
 * prilozeni se pocita velikost spolecneho pruniku obou masek (tedy, pod kolika pixely
 * z masky \e pattern se nachazely take pixely ze vstupu \e in). Vysledne pocty jsou
 * ukladany do vystupniho obrazu \e out.
 */
void PatternMatching(Image3d<GRAY8> const &in,
							Image3d<GRAY8> const &pattern,
							Image3d<GRAY8> &out,
							const int max_count)
{
	//zajisti, ze alokaci vystupniho obrazu
	out.CopyMetaData(in);

	//time-saver :-)
	const i3d::Vector3d<size_t> centre=pattern.GetSize()/(size_t)2;

	//pro kazdy pixel vstupniho obrazu projdi vzdy cely vzor a spocitej kolik je tam shod
	for (size_t y=0; y < in.GetSizeY()-pattern.GetSizeY(); ++y)
		for (size_t x=0; x < in.GetSizeX()-pattern.GetSizeX(); ++x) {
			int matches=0;
			for (size_t yy=0; yy < pattern.GetSizeY(); ++yy)
				for (size_t xx=0; xx < pattern.GetSizeX(); ++xx)
					matches+=(in.GetVoxel(x+xx,y+yy,0) && pattern.GetVoxel(xx,yy,0))?  1 : 0;
			out.SetVoxel(i3d::Vector3d<size_t>(x,y,0)+centre,100*matches/max_count);
		}
}
