#include "i3d/image3d.h"
#include "pasteImage.h"


template <typename VOXEL>
void PasteImage(i3d::Image3d<VOXEL> &bigOne,
					 i3d::Image3d<VOXEL> const &smallOne,
					 i3d::Vector3d<int> const &offset)
{
	//sweep over the small image
	for (int z=0; z < (int)smallOne.GetSizeZ(); ++z)
	  for (int y=0; y < (int)smallOne.GetSizeY(); ++y)
	    for (int x=0; x < (int)smallOne.GetSizeX(); ++x) {

			//compute coordinate within the bigOne world
			i3d::Vector3d<int> newPos(offset);
			newPos += i3d::Vector3d<int>(x,y,z);

			//if it fits into the bigOne image, paste it there
			if (bigOne.Include(newPos))
				bigOne.SetVoxel(newPos,smallOne.GetVoxel(x,y,z));
		 }
}


template void PasteImage(i3d::Image3d<i3d::GRAY8> &bigOne,
					 i3d::Image3d<i3d::GRAY8> const &smallOne,
					 i3d::Vector3d<int> const &offset);

template void PasteImage(i3d::Image3d<i3d::RGB> &bigOne,
					 i3d::Image3d<i3d::RGB> const &smallOne,
					 i3d::Vector3d<int> const &offset);

template void PasteImage(i3d::Image3d<float> &bigOne,
					 i3d::Image3d<float> const &smallOne,
					 i3d::Vector3d<int> const &offset);
