#ifndef MY_SIMILARITYMEASURES
#define MY_SIMILARITYMEASURES


#include "i3d/image3d.h"


/**
 * The function computes the SAVD (Sum of Absolute Valued Difference)
 * over the whole two input images \e A and \e B. The images should be,
 * therefore, of the same size.
 */
template <typename VOXEL>
float ComputeSAVD(i3d::Image3d<VOXEL> const &A,
					 i3d::Image3d<VOXEL> const &B);

/**
 * The function computes the SAVD (Sum of Absolute Valued Difference)
 * over the respective VOIs of the two input images \e A and \e B. The
 * size of the VOIs should be, therefore, of the same.
 */
template <typename VOXEL>
float ComputeSAVD(i3d::Image3d<VOXEL> const &A,
					 i3d::VOI<i3d::PIXELS> const & voiA,
					 i3d::Image3d<VOXEL> const &B,
					 i3d::VOI<i3d::PIXELS> const & voiB);

#endif
